/*
 * Copyright (c) 2015-2016, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *    * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *    * Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 *    * Neither the name of The Linux Foundation nor the names of its
 *      contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef GPT_H_
#define GPT_H_
/* ================================================ [ INC   ] ====================================================== */
#include "ctypes.h"
#include "errno.h"
/* ================================================ [ MACRO ] ====================================================== */
/* maximum number timers each OSTimer A & B */
#define GPT_MAX_TIMER 6
/* maximum number timers each OSTimer M3 */
#define GPT_MAX_TIMER_M3 3

/* Identifier of the Watchdog 1st stage timer in each OSTimer A & B & M3*/
#define GPT_WDG_TIMER(chip) ((eGptOsTimerM3==(chip)) ? 2 : 5)

/* ================================================ [ TYPE  ] ====================================================== */
typedef enum
{
    eGptOsTimerA,
    eGptOsTimerB,
    eGptOsTimerM3,
    eGptChipMax
}eGptChipId;

/* Callback function of GPT timer interrupts */
typedef void ( xGptTimerISR )( eGptChipId eChipId,uint8_t ucGptIdx,void *pxData);
/* Callback function of Watch dog first timeout  interrupts */
typedef xGptTimerISR xGptWatchdogISR;

typedef struct
{
    /* @TIMER_DIV
     * Timer clock division
     * The frequency of timer is f=(ioclk)/(TIMER_DIV+1)
     * The timer interval which is the period between two
     * interrupts generated by a timer is calculated using
     * the following equation:
     * (TIMER_DIV+1) x (MATCH VALUE+1) /(IOCLK)
     */
    uint16_t TIMER_DIV;
    /* @LOOP_EN
     * 0: if counter matches the value of match register, set
     * interrupts and stops count. And set bit[0] in this
     * register to zero
     * 1: if counter matches the value of match register, set
     * interrupts and recount from zero again
     */
    uint8_t  LOOP_EN;
    /* @INTR_EN
     * 0:doesn’t generate interrupts if the counter
     * matches the value of matches register
     * 1:generates interrupts if the counter matches the
     * value of matches register
     */
    uint8_t  INTR_EN;

    /* @uxPeriod
     * Timer match value
     */
    uint32_t uxPeriod;
}xGptParameter;

typedef struct
{
    /* @TIMER_DIV1
     * Timer clock division
     * The frequency of the first stage timer is f=(ioclk)/(TIMER_DIV1+1)
     */
    uint16_t TIMER_DIV1;
    /* @TIMER_DIV2
     * Timer clock division
     * The frequency of the second stage timer is f=(ioclk)/(TIMER_DIV2+1)
     */
    uint16_t TIMER_DIV2;
    /* @ux1stPeriod
     * The first stage watchdog period when timeout
     * will trigger intr_watchdog_1st interrupt and start
     * the second stage counter.
     */
    uint32_t ux1stPeriod;
    /* @ux2ndPeriod
     * The second stage watchdog period when timeout will
     * perform watchdog reset immediately. once started, can't be stopped.
     */
    uint32_t ux2ndPeriod;
}xWdgParameter;
/* ================================================ [ DATA  ] ====================================================== */
/* ================================================ [ FUNC  ] ====================================================== */
/**
 * gpt. h
 *<pre> int32_t xGptInitialize( eGptChipId eChipId ); </pre>
 *
 * Do initialization of the CSRatlas7 OS Timer A, B, or M3
 * Allocate Resource mainly.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * @return 0 if the OS Timer was successfully initialized, others return
 * an errno specified in file "errno.h"
 *
 * \defgroup xGptInitialize xGptInitialize
 * \ingroup OSTimer
 */
int32_t xGptInitialize( eGptChipId eChipId );

/**
 * gpt. h
 *<pre> void vGptDeinitialize( eGptChipId eChipId ); </pre>
 *
 * Do de-initialization of the CSRatlas7 OS Timer A, B, or M3
 * Free Resource mainly.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * \defgroup vGptDeinitialize vGptDeinitialize
 * \ingroup OSTimer
 */
void    vGptDeinitialize( eGptChipId eChipId );

/**
 * gpt. h
 *<pre> void    vGptUnRegisterInterrupt( eGptChipId eChipId, uint8_t ucGptIdx ); </pre>
 *
 * un-register a interrupt handler for the <ucGptIdx> timer of the CSRatlas7 OS Timer <eChipId>.
 *  Note: stop the timer firstly, and then do interrupt un-register
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * @param ucGptIdx Identifier to one timer of the CSRatlas7 OS Timer <eChipId>
 *
 * \defgroup vGptUnRegisterInterrupt vGptUnRegisterInterrupt
 * \ingroup OSTimer
 */
void    vGptUnRegisterInterrupt( eGptChipId eChipId, uint8_t ucGptIdx );

/**
 * gpt. h
 *<pre> int32_t xGptRegisterInterrupt(  xGptTimerISR *pxGptIsr,
                                        eGptChipId eChipId,
                                        uint8_t ucGptIdx,
                                        void *pxData ) </pre>
 *
 * Register a interrupt handler for the <ucGptIdx> timer of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param pxGptIsr Interrupt handler
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * @param ucGptIdx Identifier to one timer of the CSRatlas7 OS Timer <eChipId>
 *
 * @param pxData Pointer to user data which will passed to the interrupt handler when invoked
 *
 * @return 0 if the interrupt handler was successfully registered, others return
 * an errno specified in file "errno.h"*
 *
 * \defgroup xGptRegisterInterrupt xGptRegisterInterrupt
 * \ingroup OSTimer
 */
int32_t xGptRegisterInterrupt( xGptTimerISR *pxGptIsr, eGptChipId eChipId, uint8_t ucGptIdx, void *pxData );

/**
 * gpt. h
 *<pre> int32_t xGptStartTimer( eGptChipId eChipId, uint8_t ucGptIdx, const xGptParameter* pxParam ); </pre>
 *
 * Start the <ucGptIdx> timer of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * @param ucGptIdx Identifier to one timer of the CSRatlas7 OS Timer <eChipId>
 *
 * @param pxParam Pointer to the detailed timer configuration parameter, see xGptParameter
 *
 * @return 0 if the timer was successfully started, others return
 * an errno specified in file "errno.h"
 *
 * Example usage:
   <pre>
    // OSTimer interrupt callback
    void OSTimerInterruptHandle(eGptChipId eChipId,uint8_t ucGptIdx,void *pxData)
    {
        // TO BE DEFINED
    }

    // Start Action
    int32_t errno = xGptInitialize(eGptOsTimerA);
    if( 0 == errno )
    { // initialization OK
        xGptParameter xParam;
        errno = xGptRegisterInterrupt(OSTimerInterruptHandle,eGptOsTimerA,3,NULL);
        configAssert(0==errno);
        xParam.TIMER_DIV=1;
        xParam.LOOP_EN=1;
        xParam.INTR_EN=1;
        xParam.uxPeriod = configSOC_IO_CLK; // 2 second parameter, loop mode
        errno = xGptStartTimer(eGptOsTimerA,3,&xParam);
        configAssert(0==errno);
        // then on each 2s, OSTimerA timer 3 will generate a interrupt
        // thus will invoke OSTimerInterruptHandle(eGptOsTimerA,3,NULL)
    }
    else
    {
        // something wrong
    }
   </pre>
 *
 * \defgroup xGptStartTimer xGptStartTimer
 * \ingroup OSTimer
 */
int32_t xGptStartTimer( eGptChipId eChipId, uint8_t ucGptIdx, const xGptParameter* pxParam );

/**
 * gpt. h
 *<pre> void    vGptStopTimer( eGptChipId eChipId, uint8_t ucGptIdx ); </pre>
 *
 * Stop the <ucGptIdx> timer of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * @param ucGptIdx Identifier to one timer of the CSRatlas7 OS Timer <eChipId>
 *
 * \defgroup vGptStopTimer vGptStopTimer
 * \ingroup OSTimer
 */
void    vGptStopTimer( eGptChipId eChipId, uint8_t ucGptIdx );

/**
 * gpt. h
 *<pre> int32_t xGptStart64Timer( eGptChipId eChipId, uint16_t xTIMER_DIV ); </pre>
 *
 * Start the 64 bit timer of the CSRatlas7 OS Timer <eChipId>.
 * This 64 bit timer is always running, call this API will change
 * the clock frequency, reset the timer to 0 and then on counting from 0.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B
 *
 * @param xTIMER_DIV Timer clock division
 * The frequency of timer is f=(ioclk)/(TIMER_DIV+1)
 *
 * @return 0 if the timer was successfully started, others return
 * an errno specified in file "errno.h"
 *
 * \defgroup xGptStart64Timer xGptStart64Timer
 * \ingroup OSTimer
 */
int32_t xGptStart64Timer( eGptChipId eChipId, uint16_t xTIMER_DIV );

/**
 * gpt. h
 *<pre> uint64_t xGptRead64Timer( eGptChipId eChipId ) </pre>
 *
 * Read the value of the 64 bit timer of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B
 *
 * @return the current value of the 64 bit timer value
 *
 * \defgroup xGptRead64Timer xGptRead64Timer
 * \ingroup OSTimer
 */
uint64_t xGptRead64Timer( eGptChipId eChipId );

/**
 * gpt. h
 *<pre> int32_t xGptStartWdg( eGptChipId eChipId,const xWdgParameter* pxParam); </pre>
 *
 * Start the watchdog timer 5 of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 * Note: this is a driver treat M3 as totally standard-alone ECU, so this driver is possible to
 * access all the WDG unit of each timer. In real application, the driver for M3 only has the
 * M3 WDG unit and the WDG 1st timeout ISR from A7 OS Timer A. And the A7 secure core only has
 * access right to OS Timer WDG unit and the the WDG 1st timeout ISR from M3 Timer WDG unit.
 * For OS TImer B the 1st stage WDG ISR isn't connected to any core,  check the OS Timer B
 * WDG status to know whether the application has hang or not.
 *
 * But as that the intr_watchdog_1st interrupt is generated in addition to the counter 5’s interrupt
 * so for those OS Timer which has no connectivity to M3, this driver use the counter 5's interrupt
 * as the watch_dog 1st stage ISR, thus a simulation of the watchdog 1st timeout ISR.
 *
 * @param pxParam Pointer to the detailed timer configuration parameter, see xWdgParameter
 *
 * @return 0 if the timer was successfully started, others return
 * an errno specified in file "errno.h"
 *
 * Example usage:
   <pre>
   	// A7 Timer A to M3 WDG interrupt
	static void prvWdgHandler( eGptChipId eChipId,uint8_t ucGptIdx,void *pxData)
	{
		// TO BE DEFINED
	}
    // Start Action
    int32_t errno = xGptInitialize(eGptOsTimerA);
    if( 0 == errno )
    {   // initialization OK
        xWdgParameter xParam;
        xParam.TIMER_DIV1=0;
        xParam.TIMER_DIV2=0;
        xParam.ux1stPeriod = configSOC_IO_CLK/10; // 100 millisecond 1st stage counter
        xParam.ux2ndPeriod = configSOC_IO_CLK/2;  // 500 millisecond 2nd stage counter
		xGptRegisterWdgInterrupt( prvWdgHandler, eGptOsTimerA, NULL );
        errno = xGptStartWdg(eGptOsTimerA,&xParam);
        // then on before each 100 millisecond timeout, the application should call
        // xGptFeedWdg(eGptOsTimerA) to feed the dog to prevent watch dog reset.
    }
    else
    {
        // something wrong
    }
   </pre>
 *
 * \defgroup xGptStartWdg xGptStartWdg
 * \ingroup OSTimer
 */
int32_t xGptStartWdg( eGptChipId eChipId,const xWdgParameter* pxParam);

/**
 * gpt. h
 *<pre> int32_t xGptFeedWdg( eGptChipId eChipId); </pre>
 *
 * Feed the watchdog timer 5 of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * @return 0 if the timer was successfully feet, others return
 * an errno specified in file "errno.h"
 *
 * \defgroup xGptFeedWdg xGptFeedWdg
 * \ingroup OSTimer
 */
int32_t xGptFeedWdg( eGptChipId eChipId);

/**
 * gpt. h
 *<pre> void    vGptStopWdg( eGptChipId eChipId ); </pre>
 *
 * Stop the watchdog timer 5 of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * \defgroup vGptStopWdg vGptStopWdg
 * \ingroup OSTimer
 */
void    vGptStopWdg( eGptChipId eChipId);

/**
 * gpt. h
 *<pre> int32_t xGptRegisterWdgInterrupt(  xGptWatchdogISR *pxGptIsr,
                                           eGptChipId eChipId,
                                           void *pxData ) </pre>
 *
 * Register a interrupt handler for the watchdog 5th timer of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param pxGptIsr Interrupt handler
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 * For M3 application,there is only 1 watchdog interrupt from A7 to M3.
 * For the others, when first wdg stage time out,it will also trigger the timer interrupt,
 * for A/B:TIMER 5 ISR; M3:TIMER 3 ISR. So this driver use the alternative counter 5's interrupt
 * to simulate the 1st stage watchdog timeout ISR.
 *
 * Timer A:  INT_TIMER_WATCHDOG_1ST from Timer A connected to M3, this is real.
 * Timer B:  counter 5's interrupt from Timer B connected to M3, this is simulated wdg 1st timeout ISR.
 * 			 in fact, Timer B watchdog unit has no ISR connectivity to any core.
 * Timer M3: counter 3's interrupt from Timer M3 connected to M3, this is simulated wdg 1st timeout ISR.
 *           in fact, Timer M3 watchdog unit has ISR connectivity to Cortex-A7.
 *
 * @param pxData Pointer to user data which will passed to the interrupt handler when invoked
 *
 * @return 0 if the interrupt handler was successfully registered, others return
 * an errno specified in file "errno.h"*
 *
 * \defgroup xGptRegisterWdgInterrupt xGptRegisterWdgInterrupt
 * \ingroup OSTimer
 */
int32_t xGptRegisterWdgInterrupt(  xGptWatchdogISR *pxGptIsr, eGptChipId eChipId,void *pxData );

/**
 * gpt. h
 *<pre> void    xGptUnRegisterWdgInterrupt( eGptChipId eChipId ); </pre>
 *
 * un-register a interrupt handler for the watchdog 5th timer of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * \defgroup xGptUnRegisterWdgInterrupt xGptUnRegisterWdgInterrupt
 * \ingroup OSTimer
 */
#define xGptUnRegisterWdgInterrupt(eChipId)                 vGptUnRegisterInterrupt( eChipId , GPT_WDG_TIMER(eChipId) )

/**
 * gpt. h
 *<pre> uint32_t xGptGetTimerMatchNum( eGptChipId eChipId, uint8_t ucGptIdx ); </pre>
 *
 * Get the matched number of the timer <ucGptIdx> of the CSRatlas7 OS Timer <eChipId> since last started.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * @param ucGptIdx Identifier to one timer of the CSRatlas7 OS Timer <eChipId>
 *
 * @return the timer MATCH_NUM register value
 *
 * \defgroup xGptGetTimerMatchNum xGptGetTimerMatchNum
 * \ingroup OSTimer
 */
uint32_t xGptGetTimerMatchNum( eGptChipId eChipId, uint8_t ucGptIdx );

/**
 * gpt. h
 *<pre> uint32_t xGptGetTimerElapsed( eGptChipId eChipId, uint8_t ucGptIdx ); </pre>
 *
 * Get the elapsed timer value of the timer <ucGptIdx> of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * @param ucGptIdx Identifier to one timer of the CSRatlas7 OS Timer <eChipId>
 *
 * @return 0 if the timer was not started, else return the timer 32COUNTER register value
 *
 * \defgroup xGptGetTimerElapsed xGptGetTimerElapsed
 * \ingroup OSTimer
 */
uint32_t xGptGetTimerElapsed( eGptChipId eChipId, uint8_t ucGptIdx );

/**
 * gpt. h
 *<pre> uint32_t xGptGetTimerRemaining( eGptChipId eChipId, uint8_t ucGptIdx ); </pre>
 *
 * Get the remaining timer value in tick of the timer <ucGptIdx> of the CSRatlas7 OS Timer <eChipId>.
 *
 * @param eChipId Identifier to the CSRatlas7 OS Timer A, B, or M3
 *
 * @param ucGptIdx Identifier to one timer of the CSRatlas7 OS Timer <eChipId>
 *
 * @return 0 if the timer was not started, else return the timer (32MATCH-32COUNTER) register value.
 *
 * \defgroup xGptGetTimerRemaining xGptGetTimerRemaining
 * \ingroup OSTimer
 */
uint32_t xGptGetTimerRemaining( eGptChipId eChipId, uint8_t ucGptIdx );

#endif /* GPT_H_ */
